function [C, d] = pcavp1(p, q)

I = imread('7.bmp');

J = uint8(zeros(192, 192, 6)); 

J(:,:,1)  = I(4:195, 5:196);
J(:,:,2)  = I(4:195, 234:425);
J(:,:,3)  = I(4:195, 463:654);
J(:,:,4)  = I(217:408, 5:196);
J(:,:,5)  = I(217:408, 234:425);
J(:,:,6)  = I(217:408, 463:654);

dp = 192/p;

n = 1;
for i=1:6
    for j=1:p
        K(:,:,n) = J(1+dp*(j-1):dp*j, 1+dp*(j-1):dp*j, i);
        x(:,n) = double(span(K(:,:,n)));
        n = n+1;
    end
end

m = mean(x,2);
A = x - kron(m,ones(1,p*6));

s = A'*A/size(A,1);
[E, L] = eig(s);

E = E(:,p*6+1-q:p*6);

U = A*E;

C = U'*A;
%C = L' * C;

%for j=1:p*6
%    C(j,:) = (C(j,:)-mean(C(j,:)))/std(C(j,:));    
%end

%c = ['k' 'm' 'c' 'r' 'g' 'b'];
    
%for i=1:6
%    plot(C(6*p-1,i*p-p+1:i*p), C(6*p,i*p-p+1:i*p), strcat(c(i), '+'));
%    hold on;
%end

for i=1:6*p-1
    d(i,i) = 0;
    for j=i+1:6*p
        d(j,i) = sqrt(sum((C(:,i)-C(:,j)).^2));
        d(i,j) = d(j,i);
    end
end
